from calc_p_for_F import calc_p

class CANOVA_Ind:
    def __init__(self, Y):
        self.Y = Y

    def calc(self):
        a = len(self.Y)
        N = len(self.Y[0])
        print("a = %d"%a)
        print("N = %d"%N)
        Yd = []
        for j in range(0, a):
            sum = 0.0
            for i in range(0, N):
                sum += self.Y[j][i]
            Yd.append(sum / N)

        sum = 0.0
        for j in range(0, a):
            sum += Yd[j]
        Ydd = sum / a;

        SSA = 0.0
        SSS_A = 0.0
        for j in range(0, a):
            SSA += N * ((Yd[j] - Ydd) ** 2.0)
            for i in range(0, N):
                SSS_A += (self.Y[j][i] - Yd[j]) ** 2.0

        SST = SSA + SSS_A
        dfA = a - 1
        dfS_A = a * (N - 1)
        MSA = SSA / dfA
        MSS_A = SSS_A / dfS_A
        F = MSA / MSS_A
        p = calc_p( F, dfA, dfS_A )

        return a, N, SSA, SSS_A, SST, dfA, dfS_A, MSA, MSS_A, F, p

